#include <cstdlib>
#include <cstring>
#include <iostream>
#include "student.h"

using namespace std;

Student::Student (void) { Name = NULL; Group = 0; } //1

Student::Student (char *newName, int newGroup=0) { //2
 setGroup (newGroup);
 int n=strlen(newName);
 if (n>0) {
  Name = new char [n+1];
  if (Name!=NULL) strcpy(Name,newName);
 }
}

Student::Student (Student &From) { //3
 setGroup (From.Group);
 if (From.Name==NULL) { Name=NULL; return; }
 int n=strlen(From.Name);
 if (n>0) {
  Name = new char [n+1];
  if (Name) strcpy (Name,From.Name);
 }
}

Student::~Student () { if (Name) delete[] Name; }

void Student::setName (char *newName) { //4
 int n=strlen(newName);
 if (n>0) {
  if (Name) delete[] Name; 
  Name = new char [n+1];
  if (Name) strcpy(Name,newName);
 }
}

void Student::setGroup (int g) { Group=g; }
char * Student::getName () { return Name; }
int Student::getGroup () { return Group; }

void Student::showStudent (void) { //5
 cout << endl << (Name==NULL?"NULL":Name) << ", " << Group;
}

void Hobbit::showStudent() {
 this->Student::showStudent(); //   !
 cout << ", " << Hobby; // ""  
}

Hobbit * Construct (Hobbit &From) { 
 //  ,    , 
 //      
 Hobbit *NewHobbit = new Hobbit(From.getName(),From.getGroup(),From.getHobby());
 return NewHobbit;
}
